// Tokenizer.cpp : Implementation of CTokenizer
#include "stdafx.h"
#include "Komponent2.h"
#include "Tokenizer.h"

/////////////////////////////////////////////////////////////////////////////
// CTokenizer

STDMETHODIMP CTokenizer::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ITokenizer
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CTokenizer::Tokenize(LPCSTR sin, LPSTRVect *sout)
{
	// TODO: Add your implementation code here

   /* Establish string and get the first token: */
	LPSTR strtmp=(LPSTR)malloc(strlen(sin)+1);
	strcpy(strtmp,sin);
	(*sout).ile=0;
	(*sout).token=NULL;
	LPSTR token;
	token = strtok( strtmp, " " );
   while( token != NULL )
   {
      /* While there are tokens in "string" */
	   ((*sout).ile)++;
		(*sout).token=(LPSTR*)CoTaskMemRealloc((*sout).token,((*sout).ile)*sizeof(LPSTR*));
		(*sout).token[(*sout).ile-1]=(LPSTR)CoTaskMemAlloc(strlen(token)+1);
		strcpy((*sout).token[(*sout).ile-1],token);
      /* Get next token: */
      token = strtok( NULL, " " );
   }
   free(strtmp);
	return S_OK;
}
